<?php

/**
 * PHP Class for handling Encryption an decryption in database
 *
 * @class Google2FACrypt
 * @author Norman Thimm
 * @copyright 2015 Norman Thimm
 * @license http://www.gnu.org/licenses/ GNU Affero General Public License
 * @link http://www.familiethimm.de/
 */
class Google2FACrypt {

	/**
	 * Initialization type of cryption
	 *
	 * @return string
	 */
	protected static function initCryption() {
		$encr = Google2FAData::getCryption(); // PLUGIN_GOOGLE2FA_CRYPT
		if ($encr === "") {
			if (extension_loaded("mcrypt") && function_exists ("mcrypt_encrypt") && PLUGIN_GOOGLE2FA_CRYPT !== 'base64' && PLUGIN_GOOGLE2FA_CRYPT !== 'no')
				$encr = "mcrypt";		
			else if (function_exists ("base64_encode") && PLUGIN_GOOGLE2FA_CRYPT !== 'no')
				$encr = "base64";
			else
				$encr = "no";
			Google2FAData::setCryption($encr);
		}
		return $encr;
	}

        /**
         * Encrypt a string
         *
	 * @param string $a text to encrypt
         * @return string
         */
	public static function encrypt($a) {
		$encr = self::initCryption();
		if ($encr === "base64") {
			return base64_encode($a);
		} else if ($encr === "mcrypt") {
			$iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB);
			$iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
			return mcrypt_encrypt(MCRYPT_RIJNDAEL_256, PLUGIN_GOOGLE2FA_MCRYPTKEY, $a, MCRYPT_MODE_ECB, $iv);
		}
		return $a;
	}

        /**
         * Decrypt a string
         *
         * @param string $a text to decrypt
         * @return string
         */
	public static function decrypt($a) {
                $encr = self::initCryption();
                if ($encr === "base64") {
                        return base64_decode($a);
                } else if ($encr === "mcrypt") {
                        $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB);
                        $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
			return mcrypt_decrypt(MCRYPT_RIJNDAEL_256, PLUGIN_GOOGLE2FA_MCRYPTKEY, $a, MCRYPT_MODE_ECB, $iv);
		}
                return $a;
	}
}

?>
